﻿namespace ClassLibraryTest
{
    public class TestL
    {
        int sum = 0;
        public int[] ves = { 8, 7, 6, 5, 4, 3, 2, 10, 0, 9, 8, 7, 6, 5, 4, 3, 2 };

        public char[] create_vin()
        {
            char[] ishodnii_vin_mas = new char[17];
            char[] exclude = { 'I', 'Q', 'O' };
            Random r = new Random();

            for (int i = 0; i < 8; i++)
            {
                ishodnii_vin_mas[i] = (char)r.Next(48, 91);
                if (i == 8 && ishodnii_vin_mas[8] > 57 && ishodnii_vin_mas[8] != 88)
                {
                    i--;
                }
                if (Array.IndexOf(exclude, ishodnii_vin_mas[i]) >= 0 || (ishodnii_vin_mas[i] > 57 && ishodnii_vin_mas[i] < 65) || ishodnii_vin_mas[0] == '0')
                {
                    i--;
                }
            }

            for (int i = 9; i < 13; i++)
            {
                ishodnii_vin_mas[i] = (char)r.Next(65, 91);
                if (Array.IndexOf(exclude, ishodnii_vin_mas[i]) >= 0) i--;
            }
            for (int i = 13; i < 17; i++)
            {
                ishodnii_vin_mas[i] = (char)r.Next(48, 58);
            }
            char[] kSum = { '0', '0', '2', '3', '4', '5', '6', '7', '8', '9', 'X' };
            //ishodnii_vin_mas[]
            char[] clon_array = new char[ishodnii_vin_mas.Length];
            Array.Copy(ishodnii_vin_mas, clon_array, ishodnii_vin_mas.Length);
            clon_array[8] = (char)(raschetSum(toIntArray(perevodVEkvivalent(clon_array))));
            int chislo = clon_array[8];
            string s = chislo.ToString();
            char c = char.Parse(s);
            ishodnii_vin_mas[8] = c;
            return ishodnii_vin_mas;
        }

        public static string? vin;

        public void Main()
        {
            Console.WriteLine("Что вы хотите сделать?");
            Console.WriteLine("1. Проверить VIN на достоверность");
            Console.WriteLine("2. Сгенерировать достоверный VIN");
            Console.WriteLine("Выберите цифру:");
            int vibor = Convert.ToInt32(Console.ReadLine());
            if (vibor == 2) generationTrueVin();
            else if (vibor == 1)
            {
                Console.WriteLine("Введите VIN:");
                vin = Console.ReadLine();
                proverkaVin();
            }
            else Console.WriteLine("Неверный номер. Попробуйте снова");
        }

        public void proverkaVin()
        {
            if (vin.Length < 17 || vin.Length > 17) throw new IndexOutOfRangeException();
            Console.WriteLine();
            char[] ishodnii_vin_mas = new char[vin.Length];
            ishodnii_vin_mas = vin.ToCharArray();
            
            int tumbler = 0;
            if (ishodnii_vin_mas[8] == 'X') tumbler = 1;
            if ((ishodnii_vin_mas[8] < 49 && ishodnii_vin_mas[8] > 57) && ishodnii_vin_mas[8] != 88)
            {
                throw new Exception("В идентификационном номере есть недопустимые символы. Проверьте номер и попробуйте снова");
            }

            char[] clon_array = create_vin();
            raschetSum(toIntArray(perevodVEkvivalent(clon_array)), tumbler);
            foreach (char c in ishodnii_vin_mas)
            {
                Console.Write(c);
            }
            //Console.WriteLine(clon_array);
        }

        public void generationTrueVin()
        {
            char[] ishodnii_vin_mas = create_vin();
            char[] clon_array = new char[ishodnii_vin_mas.Length];
            Array.Copy(ishodnii_vin_mas, clon_array, ishodnii_vin_mas.Length);
            int tumbler = 0;
            if (ishodnii_vin_mas[8] == 'X') tumbler = 1;
            if (ishodnii_vin_mas[8] < 49 && ishodnii_vin_mas[8] > 57 && ishodnii_vin_mas[8] != 88)
            {
                throw new Exception("В идентификационном номере есть недопустимые символы. Проверьте номер и попробуйте снова");
            }

            foreach (char c in ishodnii_vin_mas)
            {
                //Console.Write(c);
                vin += c;
            }
            //vin = ishodnii_vin_mas.ToString();
            proverkaVin();
            //clon_array[8] = (char)(raschetSum(toIntArray(perevodVEkvivalent(clon_array))));
            //raschetSum(toIntArray(perevodVEkvivalent(clon_array)), tumbler);
            Console.WriteLine();
        }

        public char[] perevodVEkvivalent(char[] ishodnii_vin_mas)
        {
            if (ishodnii_vin_mas.Length < 17 || ishodnii_vin_mas.Length > 17) throw new ArgumentException();
            int[] chislovoi_ekvivalent_mas = { 1, 2, 3, 4, 5, 6, 7, 8, 0, 1, 2, 3, 4, 5, 0, 7, 0, 9, 2, 3, 4, 5, 6, 7, 8, 9 };
            for (int i = 0; i < ishodnii_vin_mas.Length; i++)
            {
                if (ishodnii_vin_mas[i] == 'I' || ishodnii_vin_mas[i] == 'Q' || ishodnii_vin_mas[i] == 'O')
                {
                    throw new Exception("В идентификационном номере есть недопустимые символы. Проверьте номер и попробуйте снова");
                }
                if ((int)ishodnii_vin_mas[i] > 64)
                {
                    ishodnii_vin_mas[i] = (char)chislovoi_ekvivalent_mas[(int)ishodnii_vin_mas[i] - 65];
                }
            }
            return ishodnii_vin_mas;
        }

        public int[] toIntArray(char[] ishodnii_vin_mas)
        {
            if (ishodnii_vin_mas.Length < 17 || ishodnii_vin_mas.Length > 17) throw new ArgumentException();
            int[] novii_vin_mas = new int[ishodnii_vin_mas.Length];
            for (int i = 0; i < ishodnii_vin_mas.Length; i++)
            {
                if ((int)ishodnii_vin_mas[i] > 9)
                {
                    //Console.Write(ishodnii_vin_mas[i] + " ");
                    ishodnii_vin_mas[i] = (char)Char.GetNumericValue(ishodnii_vin_mas[i]);
                    novii_vin_mas[i] = (int)ishodnii_vin_mas[i];
                }
                else
                {
                    //Console.Write((int)ishodnii_vin_mas[i] + " ");
                    novii_vin_mas[i] = (int)ishodnii_vin_mas[i];
                }
            }
            return novii_vin_mas;
        }

        public int raschetSum(int[] novii_vin_mas)
        {
            if (novii_vin_mas.Length < 17 || novii_vin_mas.Length > 17) throw new ArgumentException();
            sum = 0;
            for (int i = 0; i < novii_vin_mas.Length; i++)
            {
                sum += novii_vin_mas[i] * ves[i];
            }
            sum = (int)(sum - (Math.Floor((decimal)sum / 11) * 11));
            return sum;
        }

        public void raschetSum(int[] novii_vin_mas, int tumbler)
        {
            Console.WriteLine();
            if (raschetSum(novii_vin_mas) == novii_vin_mas[8])
            {
                Console.WriteLine("Идентификационный номер достоверен");
            }
            else if (raschetSum(novii_vin_mas) == 10 && tumbler == 1)
            {
                Console.WriteLine("Идентификационный номер достоверен");
            }
            else
            {
                throw new Exception("Идентификационный номер НЕ достоверен. Проверьте правильность написания и попробуйте снова");
            }
        }

        //public void ispravlenie(char[] ishodnii_vin_mas, int[] novii_vin_mas)
        //{
        //    string vivod = "";
        //    novii_vin_mas[8] = (int)(sum - (Math.Floor((decimal)sum / 11) * 11));
        //    for (int i = 0; i < ishodnii_vin_mas.Length; i++)
        //    {
        //        if (i == 8 && (sum - (Math.Floor((decimal)sum / 11) * 11) == 10)) vivod += "X";
        //        else vivod += ishodnii_vin_mas[i].ToString();
        //    }

        //    Console.WriteLine("Верный номер: " + vivod);
        //}
    }
}